function [alarm_res,set,blk,avg_hr] = check_arr(ri,Fs,arr,verify1)
    
   
    alarm_res = 0;
    set = [];
    blk = [];
    avg_hr = 0;
    
    b_thresh = 43;
    t_thresh = 133;
    
    if(nargin < 4)
        verify1 = 0;
    end
   
    if(verify1)
        b_thresh = 1.02*b_thresh;
        t_thresh = 0.98*t_thresh;
    end
   
    diff_ri = [];
    if(length(ri) >= 2)
        diff_ri = diff(ri);
    else
        
        return;
    end
    
    bpm = [];
    
    for i=1:1:length(diff_ri)
        bpm(i) = Fs*60/(diff_ri(i));     
    end

    if (~isempty(bpm))
        
        avg_hr = mean(bpm)/60;

        if(arr == 1)
            
            bpm_b = [];
            b_beat = [];
            b1 = 1;
            b2 = 1;
            
            b_38 = [];
            
            for i=1:1:length(bpm)

                if(bpm(i) <= b_thresh)
                    b_beat(b1) = i;
                    if(b1 == 1)
                        next_beat = i+1;
                    end
                    b1=b1+1;
                end
                
                if(bpm(i) <= 38)
                    b_38(b2) = i;
                    b2=b2+1;
                    if(~verify1)
                        if(length(bpm)>=5)
                            if(i >= (length(bpm) - 5))
                                valid_38 = 1;
                            else
                                valid_38 = 0;
                            end
                        else
                            valid_38 = 0;
                        end
                    else
                        valid_38 = 1;
                    end
                end
                
            end
            
            for i=1:1:length(diff_ri)-4
                bpm_b(i) = 5*Fs*60/(sum(diff_ri(i:i+4)));
                
            end
            
            kk=1;
            b_40=[];
            
            for i=1:1:length(bpm_b)

                if(bpm_b(i) <= b_thresh)
                    b_40(kk,(1:2)) = [i,i+5];
                    kk=kk+1;
                end
            end

            [m,~] = size(b_40);
            
            alarm_res = 0;
            
            if (m>0)
                alarm_res =1;
            end
            
            if((length(b_beat) > 3) || ((length(b_38) >= 1 && valid_38)))
                alarm_res = 1;
            end
            
            if(length(b_beat) >=2)
                set = [b_beat(1),b_beat(length(b_beat))];
            elseif (length(b_beat) == 1)
                set = [b_beat(1),next_beat];
            else
                set = [];
            end
            blk = b_40;
%             
%             b_beat
%             b_38
%             bpm
%             blk
%         
        elseif (arr == 2)
            
            bpm_t = [];
            t_beat = [];
            t1 = 1;
            t2 = 1;
            t3 = 1;
            t4 = 1;
            
            t_150 = [];
            t_180 = [];
            t_200 = [];
            
            for i=1:1:length(bpm)

                if(bpm(i) >= t_thresh)
                    t_beat(t1) = i;
                    if(t1 == 1)
                        next_beat = i+1;
                    end
                    t1=t1+1;
                end
                
                if(bpm(i) >= 150)
                    t_150(t2) = i;
                    t2=t2+1;
                end
                
                if(bpm(i) >= 180)
                    t_180(t3) = i;
                    t3=t3+1;
                end
                
                if(bpm(i) >= 200)
                    t_200(t4) = i;
                    t4=t4+1;
                    if(length(bpm)>=5)
                        if(i >= (length(bpm) - 5))
                            valid_200 = 1;
                        else
                            valid_200 = 0;
                        end
                    else
                        valid_200 = 0;
                    end
                end
                
            end
%             t_beat
%             bpm(t_beat)
            for i=1:1:length(diff_ri)-16
                bpm_t(i) = 17*Fs*60/(sum(diff_ri(i:i+16)));
            end
            
            k2=1;
            t_140=[];
            
            
            for i=1:1:length(bpm_t)

                if(bpm_t(i) >= t_thresh)
                    t_140(k2,(1:2)) = [i,i+17];
                    k2=k2+1;
                end
                
            end
            
            
            [m1,~] = size(t_140);
            alarm_res = 0;
            
            if(m1 > 0)
                alarm_res = 1;

            end
            
            if((length(t_beat) >= 8) || (length(t_150) >= 5) || (length(t_180) >= 3) || ((length(t_200) >= 1 && valid_200)))
                
                alarm_res = 1;
            end
            
            if(length(t_beat) >=2)
                set = [t_beat(1),t_beat(length(t_beat))];
            elseif (length(t_beat) == 1)
                set = [t_beat(1),next_beat];
            else
                set = [];
            end
            
            blk = t_140;
        end
    end
