function [xft_abs,freq] =  plot_fft(x,Fs,holdval,plotfig)


if (nargin < 4)
    plotfig = 1;
end  

if (nargin < 3)
    holdval = 0;
end  

xft = fft(x);
xft_abs = abs(xft);

%xft_abs = xft_abs/(max(xft_abs));
t = 0:1/Fs:length(x)/Fs;
no_samples = length(t);
div = no_samples/Fs;

freq = 0:1/div:length(x)/(2*div);
xft_abs = xft_abs(1:length(x)/2+1);
if(plotfig)
    if (holdval == 0)
        figure, plot(freq,xft_abs/max(xft_abs))
    else

        plot(freq,xft_abs/max(xft_abs),'g')

    end
end